#include "../btree.h"
#include <iostream>
#include <vector>
#include <string>

int main(int argc, char *argv[])
{
  if (argc != 2) {
    std::cerr << "Usage: " << argv[0] << " dbname" << std::endl; 
    exit(1);
  }

  Lux::IO::Btree *bt = new Lux::IO::Btree(Lux::IO::CLUSTER);
  if (!bt->open(argv[1], Lux::IO::DB_CREAT)) {
    std::cerr << "open failed" << std::endl;
    exit(-1);
  }

  std::vector<std::string> vec;
  vec.push_back("aa");
  vec.push_back("c");
  vec.push_back("e");
  vec.push_back("g");
  vec.push_back("i");
  for (int i = 0; i < vec.size(); ++i) {
    const char *key = vec[i].c_str();
    if (!bt->put(key, strlen(key), &i, sizeof(int))) {
      std::cerr << "put failed" << std::endl;
    }
  }

  Lux::IO::cursor_t *c = bt->cursor_init();
  char buf[32] = "j";
  Lux::IO::data_t key;
  key.data = buf;
  key.size = 1;
  if (bt->lower_bound(c, &key)) {
    Lux::IO::data_t *k, *v;
    if (!bt->cursor_get(c, &k, &v, Lux::IO::SYSTEM)) {
      std::cerr << "cursor_get failed" << std::endl;
    }
    std::cout << "key: [" << (char *) (k->data) << "], val: [" << *(int *) (v->data) << "]" << std::endl;
  }

  return 0;
}
